var acidOrAlk = 0;
var HAGMA = 0;
var NAGMA = 0;
var respAcid = 0;
var metAlk = 0;
var respAlk = 0;
var error = 0;
var errorText = "";
var count = 0;
var expectPCO2  = 0;
var expectBicarb = 0;
var compensate = 0;
var albumin = 0;
var glucose = 0;
var BUN = 0;
var negAG = 0;
var compensatoryText = "";
var NORMAL_BICARB = 25;
var NORMAL_PCO2 = 40;
var NORMAL_BICARB_LOW = 23;
var NORMAL_BICARB_HIGH = 28;
var NORMAL_PCO2_LOW = 35;
var NORMAL_PCO2_HIGH = 45;
var finalAnswer = new Array(4);
//var useSIUnits = "no";
var expectedAG = 0;
var calcAG = 0;
var calcOsm = 0;
var osmolarGap = 0;
var deltaDelta = 0;
//consolidate all variables into this!
var pageCaller = "";
var bothOGAG = 0;
var aaGradient = 0;
var normalAAGradient = 0;

//var document = this.document;
//var window = this.window;
//function alert() {
//	"use strict";
//}
function trim1 (str) {
    return str.replace(/^\s\s*/, '').replace(/\s\s*$/, '');
}
function clearAllFields() {
	"use strict";
    //alert("hello");
	document.getElementById('aa_age').value = "";
	document.getElementById('aa_atm').value = "760";
	document.getElementById('aa_PO2').value = "";
	document.getElementById('aa_PCO2').value = "";
	document.getElementById('aa_FiO2').value = "";
	document.getElementById('s_pH').value = "";
	document.getElementById('s_pCO2').value = "";
	document.getElementById('s_bicarb').value = "";
	document.getElementById('c_pH').value = "";
	document.getElementById('c_pCO2').value = "";
	document.getElementById('c_bicarb').value = "";
	document.getElementById('c_na').value = "";
	document.getElementById('c_cl').value = "";
	if (document.getElementById('siUnits').checked === true) {
		document.getElementById('c_alb').value = 40;
		document.getElementById('o_alb').value = 40;
	} else {
		document.getElementById('c_alb').value = 4;
		document.getElementById('o_alb').value = 4;
	}
	document.getElementById('o_pH').value = "";
	document.getElementById('o_pCO2').value = "";
	document.getElementById('o_bicarb').value = "";
	document.getElementById('o_na').value = "";
	document.getElementById('o_cl').value = "";
	document.getElementById('o_sosm').value = "";
	document.getElementById('o_glucose').value = "";
	document.getElementById('o_BUN').value = "";
    
    document.getElementById('og_sosm').value = "";
    document.getElementById('og_na').value = "";
    document.getElementById('og_glucose').value = "";
    document.getElementById('og_BUN').value = "";
    
}

function toggle(whichDiv, showOrHide) {
	"use strict";
	var ele = '#'+whichDiv;
	if (showOrHide === "show") {
		$(ele).show();
	} else {
		$(ele).hide();
	}
}

function setSIUnits() {
	"use strict";
    //var siUnitsValue = "";
    NativeStorage.getString("useSIUnits",
        function(value){
            //alert(value);
            //siUnitsValue = value;
            //alert(siUnitsValue);
            if (value == "yes") {
                $( "#siUnits" ).prop( "checked", true ).checkboxradio( "refresh" );
                document.getElementById('optionsBicarbLowLabel').innerHTML = "<strong>Bicarb Range (mmol/L):</strong>";
                document.getElementById("simpleBicarbLabel").innerHTML = "Bicarb (From BMP, mmol/L):";
                document.getElementById("complexBicarbLabel").innerHTML = "Bicarb (From BMP, mmol/L):";
                document.getElementById("complexNaLabel").innerHTML = "Na (mmol/L):";
                document.getElementById("complexClLabel").innerHTML = "Cl (mmol/L):";
                document.getElementById("complexAlbLabel").innerHTML = "Alb (g/L):";
                document.getElementById("c_alb").value = "40";
                document.getElementById("osmolarBicarbLabel").innerHTML = "Bicarb (From BMP, mmol/L):";
                document.getElementById("osmolarNaLabel").innerHTML = "Na (mmol/L):";
                document.getElementById("osmolarClLabel").innerHTML = "Cl (mmol/L):";
                document.getElementById("serumOsmLabel").innerHTML = "Serum Osm (mmol/kg):";
                document.getElementById("osmolarGlucoseLabel").innerHTML = "Glucose (mmol/L):";
                document.getElementById("osmolarBUNLabel").innerHTML = "BUN (mmol/L):";
                document.getElementById("osmolarAlbLabel").innerHTML = "Alb (g/L):";
                document.getElementById("o_alb").value = 40;
                document.getElementById("ogNaLabel").innerHTML = "Na (mmol/L):";
                document.getElementById("ogSerumOsmLabel").innerHTML = "Serum Osm (mmol/kg):";
                document.getElementById("ogGlucoseLabel").innerHTML = "Glucose (mmol/L):";
                document.getElementById("ogBUNLabel").innerHTML = "BUN (mmol/L):";
                document.getElementById("optionsBicarbLowLabel").innerHTML = "<strong>Bicarb Range (mmol/L):</strong>";
            }
            else {
                $( "#siUnits" ).prop( "checked", false ).checkboxradio( "refresh" );
                document.getElementById('optionsBicarbLowLabel').innerHTML = "<strong>Bicarb Range (mEq/L):</strong>";
                document.getElementById("simpleBicarbLabel").innerHTML = "Bicarb (From BMP, mEq/L):";
                document.getElementById("complexBicarbLabel").innerHTML = "Bicarb (From BMP, mEq/L):";
                document.getElementById("complexNaLabel").innerHTML = "Na (mEq/L):";
                document.getElementById("complexClLabel").innerHTML = "Cl (mEq/L):";
                document.getElementById("complexAlbLabel").innerHTML = "Alb (mg/L):";
                document.getElementById("c_alb").value = "4";
                document.getElementById("osmolarBicarbLabel").innerHTML = "Bicarb (From BMP, mEq/L):";
                document.getElementById("osmolarNaLabel").innerHTML = "Na (mEq/L):";
                document.getElementById("osmolarClLabel").innerHTML = "Cl (mEq/L):";
                document.getElementById("serumOsmLabel").innerHTML = "Serum Osm (mOsm/kg):";
                document.getElementById("osmolarGlucoseLabel").innerHTML = "Glucose (mg/dL):";
                document.getElementById("osmolarBUNLabel").innerHTML = "BUN (mg/dL):";
                document.getElementById("osmolarAlbLabel").innerHTML = "Alb (mg/L):";
                document.getElementById("o_alb").value = 4;
                document.getElementById("ogNaLabel").innerHTML = "Na (mEq/L):";
                document.getElementById("ogSerumOsmLabel").innerHTML = "Serum Osm (mOsm/kg):";
                document.getElementById("ogGlucoseLabel").innerHTML = "Glucose (mg/dL):";
                document.getElementById("ogBUNLabel").innerHTML = "BUN (mg/dL):";
                document.getElementById("optionsBicarbLowLabel").innerHTML = "<strong>Bicarb Range (mEq/L):</strong>";
            }
        },
        function (error){
                $( "#siUnits" ).prop( "checked", false ).checkboxradio( "refresh" );
                document.getElementById('optionsBicarbLowLabel').innerHTML = "<strong>Bicarb Range (mEq/L):</strong>";
                document.getElementById("simpleBicarbLabel").innerHTML = "Bicarb (From BMP, mEq/L):";
                document.getElementById("complexBicarbLabel").innerHTML = "Bicarb (From BMP, mEq/L):";
                document.getElementById("complexNaLabel").innerHTML = "Na (mEq/L):";
                document.getElementById("complexClLabel").innerHTML = "Cl (mEq/L):";
                document.getElementById("complexAlbLabel").innerHTML = "Alb (mg/L):";
                document.getElementById("c_alb").value = "4";
                document.getElementById("osmolarBicarbLabel").innerHTML = "Bicarb (From BMP, mEq/L):";
                document.getElementById("osmolarNaLabel").innerHTML = "Na (mEq/L):";
                document.getElementById("osmolarClLabel").innerHTML = "Cl (mEq/L):";
                document.getElementById("serumOsmLabel").innerHTML = "Serum Osm (mOsm/kg):";
                document.getElementById("osmolarGlucoseLabel").innerHTML = "Glucose (mg/dL):";
                document.getElementById("osmolarBUNLabel").innerHTML = "BUN (mg/dL):";
                document.getElementById("osmolarAlbLabel").innerHTML = "Alb (mg/L):";
                document.getElementById("o_alb").value = 4;
                document.getElementById("ogNaLabel").innerHTML = "Na (mEq/L):";
                document.getElementById("ogSerumOsmLabel").innerHTML = "Serum Osm (mOsm/kg):";
                document.getElementById("ogGlucoseLabel").innerHTML = "Glucose (mg/dL):";
                document.getElementById("ogBUNLabel").innerHTML = "BUN (mg/dL):";
                document.getElementById("optionsBicarbLowLabel").innerHTML = "<strong>Bicarb Range (mEq/L):</strong>";
        }); //window.localStorage.getItem("useSIUnits");
    /** alert(siUnitsValue);
    if (siUnitsValue == "yes") {
        //alert(siUnitsValue);
        //document.getElementById('siUnits').checked = true;

    } else {
        //document.getElementById('siUnits').checked = false;

    }
     **/
}

function loadOldOptions() {
	"use strict";
    
    //window.localStorage.getItem("useSIUnits");
    setSIUnits();
    
    NativeStorage.getString("problemType",
      function(value) {
            if (value == "chronic") {
                    $( "#chronicProblem" ).prop( "checked", true ).checkboxradio( "refresh" );
                    $( "#acuteProblem" ).prop( "checked", false ).checkboxradio( "refresh" );
                    //document.getElementById('chronicProblem').checked = true;
                    //document.getElementById('acuteProblem').checked = false;
            } else {
                    $( "#chronicProblem" ).prop( "checked", false ).checkboxradio( "refresh" );
                    $( "#acuteProblem" ).prop( "checked", true ).checkboxradio( "refresh" );
                    //document.getElementById('chronicProblem').checked = false;
                    //document.getElementById('acuteProblem').checked = true;
            
            }
      },
      function(error){
            $( "#chronicProblem" ).prop( "checked", false ).checkboxradio( "refresh" );
            $( "#acuteProblem" ).prop( "checked", true ).checkboxradio( "refresh" );
            //document.getElementById('chronicProblem').checked = false;
            //document.getElementById('acuteProblem').checked = true;
    }); //window.localStorage.getItem("problemType");
	
	
    //NORMAL_BICARB_LOW = 23;
    NativeStorage.getString("NORMAL_BICARB_LOW",
          function(value){
              
              if ((isNaN(value)) || (value === null)){
                    document.getElementById('lowBicarb').value = 23;
                    //NORMAL_BICARB_LOW = 23;
              }
              else {
                    document.getElementById('lowBicarb').value = parseFloat(value);
                    //NORMAL_BICARB_LOW = parseFloat(value);
              }
          }, function(error){
                document.getElementById('lowBicarb').value = 23;
                //NORMAL_BICARB_LOW = 23;
          }); //window.localStorage.getItem("NORMAL_BICARB_LOW");
    NORMAL_BICARB_LOW = document.getElementById('lowBicarb').value;
    //alert ("NORMAL_BICARB_LOW:" + NORMAL_BICARB_LOW);
    
    //NORMAL_BICARB_HIGH = 28;
    NativeStorage.getString("NORMAL_BICARB_HIGH",
          function(value){
             if ((isNaN(value)) || (value === null)){
                    document.getElementById('highBicarb').value = 28;
                    //NORMAL_BICARB_HIGH = 28;
              }
              else {
                    document.getElementById('highBicarb').value = parseFloat(value);
                    //NORMAL_BICARB_HIGH = parseFloat(value);
              }
          }, function(error){
                document.getElementById('highBicarb').value = 28;
                //NORMAL_BICARB_HIGH = 28;
          }); //window.localStorage.getItem("NORMAL_BICARB_HIGH");
    NORMAL_BICARB_HIGH = document.getElementById('highBicarb').value;
    
    //NORMAL_PCO2_LOW = 35;
    NativeStorage.getString("NORMAL_PCO2_LOW",
          function(value){
              if ((isNaN(value)) || (value === null)){
                    document.getElementById('lowpCO2').value = 35;
                    //NORMAL_PCO2_LOW = 35;
              }
              else{
                    document.getElementById('lowpCO2').value = parseFloat(value);
                    //NORMAL_PCO2_LOW = parseFloat(value);
                          }
          }, function(error){
                document.getElementById('lowpCO2').value = 35;
                //NORMAL_PCO2_LOW = 35;
          }); //window.localStorage.getItem("NORMAL_PCO2_LOW");
    NORMAL_PCO2_LOW = document.getElementById('lowpCO2').value;
    
    //NORMAL_PCO2_HIGH = 45;
    NativeStorage.getString("NORMAL_PCO2_HIGH",
          function(value){
              if ((isNaN(value)) || (value === null)){
                    document.getElementById('highpCO2').value = 45;
                    //NORMAL_PCO2_HIGH = 45;
              }
              else {
                    document.getElementById('highpCO2').value = parseFloat(value);
                    //NORMAL_PCO2_HIGH = parseFloat(value);
              }
          }, function(error){
                document.getElementById('highpCO2').value = 45;
                //NORMAL_PCO2_HIGH = 45;
          }); //window.localStorage.getItem("NORMAL_PCO2_HIGH");
    NORMAL_PCO2_HIGH = document.getElementById('highpCO2').value;
}

/** function toggleMenu() {
	var ele = document.getElementById("menuDiv");
	if(ele.style.display == "block") {
    	ele.style.display = "none";
  	}
	else {
		ele.style.display = "block";
	}
}
 **/

function onDeviceReady1() {
	"use strict";
    //alert("wtf");
	toggle("answer1", "hide");
	toggle("answer2", "hide");
	toggle("answer3", "hide");
	toggle("answer4", "hide");
	toggle("answer5", "hide");
	loadOldOptions();
    //document.addEventListener("menubutton", toggleMenu, false);
    document.addEventListener("backbutton", onBackKeyDown, false);
}

function onBackKeyDown() {
	var activePage = $.mobile.activePage.attr("id");
	if (activePage == "index") {
		navigator.app.exitApp();
	}
	else {
		navigator.app.backHistory();
	}
}


function errorCheckPHAndSetAcidVsBase(caller) {
	"use strict";
	var pHTextBoxID = "";
	if (caller === "simple") {
		pHTextBoxID = "s_pH";
	} else if (caller === "complex") {
		pHTextBoxID = "c_pH";
	} else if (caller === "osmolar") {
		pHTextBoxID = "o_pH";
	}
	if ((parseFloat(document.getElementById(pHTextBoxID).value) < 7.4) && (parseFloat(document.getElementById(pHTextBoxID).value) >= 6)) {
		acidOrAlk = 0;
	} else if ((parseFloat(document.getElementById(pHTextBoxID).value) >= 7.4) && (parseFloat(document.getElementById(pHTextBoxID).value) <= 8.5)) {
		acidOrAlk = 1;
	} else {
		error = 1;
		errorText = errorText + "Please Provide a Physiologic pH value. \n";
	}
}

function errorCheckSetAGOrOsm(caller) {
	"use strict";
	var Na = 0, Bicarb = 0, Cl = 0;
	if (caller === "simple") {
		if ((trim1(document.getElementById('s_pH').value) == "") || (isNaN(document.getElementById('s_pH').value)) || (parseFloat(document.getElementById('s_pH').value) <= 0) || (trim1(document.getElementById('s_pCO2').value) == "") || (isNaN(document.getElementById('s_pCO2').value)) || (parseFloat(document.getElementById('s_pCO2').value) <= 0) || (trim1(document.getElementById('s_bicarb').value) == "") || (isNaN(document.getElementById('s_bicarb').value)) || (parseFloat(document.getElementById('s_bicarb').value) <= 0)) {
			error = 1;
			errorText = errorText + "Please fill in all (pH, pCO2 & Bicarb) fields with number greater than zero. \n";
		} else {
			errorCheckPHAndSetAcidVsBase(caller);
		}
	} else if (caller === "complex") {
		if ((trim1(document.getElementById('c_pH').value) == "") || (isNaN(document.getElementById('c_pH').value)) || (parseFloat(document.getElementById('c_pH').value) <= 0) || (trim1(document.getElementById('c_pCO2').value) == "") || (isNaN(document.getElementById('c_pCO2').value)) || (parseFloat(document.getElementById('c_pCO2').value) <= 0) || (trim1(document.getElementById('c_bicarb').value) == "") || (isNaN(document.getElementById('c_bicarb').value)) || (parseFloat(document.getElementById('c_bicarb').value) <= 0) || (trim1(document.getElementById('c_na').value) == "") || (isNaN(document.getElementById('c_na').value)) || (parseFloat(document.getElementById('c_na').value) <= 0) || (trim1(document.getElementById('c_cl').value) == "") || (isNaN(document.getElementById('c_cl').value)) || (parseFloat(document.getElementById('c_cl').value) <= 0) || (trim1(document.getElementById('c_alb').value) == "") || (isNaN(document.getElementById('c_alb').value)) || (parseFloat(document.getElementById('c_alb').value) <= 0)) {
			error = 1;
			errorText = errorText + "Please fill in all (pH, pCO2, Na, Cl, Albumin & Bicarb) fields with numbers greater than zero. \n";
		} else {
			errorCheckPHAndSetAcidVsBase(caller);
		}
	} else if (caller === "osmolar") {
		if ((trim1(document.getElementById('o_pH').value) == "") || (isNaN(document.getElementById('o_pH').value)) || (parseFloat(document.getElementById('o_pH').value) <= 0) || (trim1(document.getElementById('o_pCO2').value) == "") || (isNaN(document.getElementById('o_pCO2').value)) || (parseFloat(document.getElementById('o_pCO2').value) <= 0) || (trim1(document.getElementById('o_bicarb').value) == "") || (isNaN(document.getElementById('o_bicarb').value)) || (parseFloat(document.getElementById('o_bicarb').value) <= 0) || (trim1(document.getElementById('o_na').value) == "") || (isNaN(document.getElementById('o_na').value)) || (parseFloat(document.getElementById('o_na').value) <= 0) || (trim1(document.getElementById('o_cl').value) == "") || (isNaN(document.getElementById('o_cl').value)) || (parseFloat(document.getElementById('o_cl').value) <= 0) || (trim1(document.getElementById('o_sosm').value) == "") || (isNaN(document.getElementById('o_sosm').value)) || (parseFloat(document.getElementById('o_sosm').value) <= 0) || (trim1(document.getElementById('o_alb').value) == "") || (isNaN(document.getElementById('o_alb').value)) || (parseFloat(document.getElementById('o_alb').value) <= 0) || (trim1(document.getElementById('o_glucose').value) == "") || (isNaN(document.getElementById('o_glucose').value)) || (parseFloat(document.getElementById('o_glucose').value) <= 0) || (trim1(document.getElementById('o_BUN').value) == "") || (isNaN(document.getElementById('o_BUN').value)) || (parseFloat(document.getElementById('o_BUN').value) <= 0)) {
			error = 1;
			errorText = errorText + "Please 1 fill in all (pH, pCO2, Na, Cl, Albumin, Glucose, BUN, Serum Osm & Bicarb) fields with numbers greater than zero. \n";
		} else {
			errorCheckPHAndSetAcidVsBase(caller);
		}
	} else if (caller === "OG") {
		if ((trim1(document.getElementById('og_na').value) == "") || (isNaN(document.getElementById('og_na').value)) || (parseFloat(document.getElementById('og_na').value) <= 0) || (trim1(document.getElementById('og_sosm').value) == "") || (isNaN(document.getElementById('og_sosm').value)) || (parseFloat(document.getElementById('og_sosm').value) <= 0) ||	(trim1(document.getElementById('og_glucose').value) == "") || (isNaN(document.getElementById('og_glucose').value)) || (parseFloat(document.getElementById('og_glucose').value) <= 0) || (trim1(document.getElementById('og_BUN').value) == "") || (isNaN(document.getElementById('og_BUN').value)) || (parseFloat(document.getElementById('og_BUN').value) <= 0)) {
			error = 1;
			errorText = errorText + "Please fill in all (Na, Glucose, BUN  Serum Osm ) fields with numbers greater than zero. \n";
		}
	}
}
function errorCheckAA(caller) {
	"use strict";
	if (caller != "AA") {
		error = 1;
		errorText = errorText + "Severe Bug (ID 1) please notify developer. \n";
	} else if (caller === "AA") {
		if ((trim1(document.getElementById('aa_age').value) == "") || (isNaN(document.getElementById('aa_age').value)) || (parseFloat(document.getElementById('aa_age').value) <= 0) || 
				(trim1(document.getElementById('aa_atm').value) == "") || (isNaN(document.getElementById('aa_atm').value)) || (parseFloat(document.getElementById('aa_atm').value) <= 0) ||	
				(trim1(document.getElementById('aa_PO2').value) == "") || (isNaN(document.getElementById('aa_PO2').value)) || (parseFloat(document.getElementById('aa_PO2').value) <= 0) || 
				(trim1(document.getElementById('aa_PCO2').value) == "") || (isNaN(document.getElementById('aa_PCO2').value)) || (parseFloat(document.getElementById('aa_PCO2').value) <= 0) ||	
				(trim1(document.getElementById('aa_FiO2').value) == "") || (isNaN(document.getElementById('aa_FiO2').value)) || (parseFloat(document.getElementById('aa_FiO2').value) <= 0) || (parseFloat(document.getElementById('aa_FiO2').value) > 1)) {
			error = 1;
			errorText = errorText + "Age, Local Pressure, PO2 and PCO2 should be numbers greater than zero and, FiO2 should be a decimal number between 0 and 1.\n";
		}
	}
}
function SIConversionAndCalculator(caller) {
	"use strict";
	if (caller === "simple") {
		alert("error 2!");
		//should never get called.
	} else if (caller === "complex") {
		if (document.getElementById('siUnits').checked === true) {
			albumin = parseFloat(document.getElementById('c_alb').value) / 10;
		} else {
			albumin = parseFloat(document.getElementById('c_alb').value);
		}
		expectedAG = albumin * 2.5;
		calcAG = (parseFloat(document.getElementById('c_na').value) - (parseFloat(document.getElementById('c_bicarb').value) + parseFloat(document.getElementById('c_cl').value)));
	} else if (caller === "osmolar") {
		if (document.getElementById('siUnits').checked === true) {
			albumin = parseFloat(document.getElementById('o_alb').value) / 10;
			glucose = parseFloat(document.getElementById('o_glucose').value) / 0.0555;
			BUN = parseFloat(document.getElementById('o_BUN').value) / 0.357;
		} else {
			albumin = parseFloat(document.getElementById('o_alb').value);
			glucose = parseFloat(document.getElementById('o_glucose').value);
			BUN = parseFloat(document.getElementById('o_BUN').value);
		}
		expectedAG = albumin * 2.5;
		calcAG = (parseFloat(document.getElementById('o_na').value) - (parseFloat(document.getElementById('o_bicarb').value) + parseFloat(document.getElementById('o_cl').value)));
		calcOsm = (((parseFloat(document.getElementById('o_na').value)) * 2) + (glucose/18) +  (BUN/2.8));
	} else if (caller === "OG") {
		if (document.getElementById('siUnits').checked === true) {
			glucose = parseFloat(document.getElementById('og_glucose').value) / 0.0555;
			BUN = parseFloat(document.getElementById('og_BUN').value) / 0.357;
		} else {
			glucose = parseFloat(document.getElementById('og_glucose').value);
			BUN = parseFloat(document.getElementById('og_BUN').value);
		}
		calcOsm = ((parseFloat(document.getElementById('og_na').value) * 2) + (glucose/18) +  (BUN/2.8));
	}
}
function getProblemType() {
	"use strict";
	return $('input[name=problemType]:checked').val();  
	
}
function expectedPCO2Calc(caller) {
	"use strict";
	var PCO2_id = "", BicarbId = "", countMax = 0;
	if (caller === "complex") {
		PCO2_id = "c_pCO2";
		BicarbId = "c_bicarb";
		countMax = 3;
	} else if (caller === "osmolar") {
		PCO2_id = "o_pCO2";
		BicarbId = "o_bicarb";
		countMax = 4;
	} else if (caller === "simple") {
		PCO2_id = "s_pCO2";
		BicarbId = "s_bicarb";
		countMax = 2;
	}
	expectPCO2 = NORMAL_PCO2;
	if (((NAGMA === 1) || (HAGMA === 1)) && (acidOrAlk === 0)) {
		if (getProblemType() === "a") {
			expectPCO2 = Math.round((1.5 * parseFloat(document.getElementById(BicarbId).value)) + 8);
		} else {
			expectPCO2 = parseFloat(document.getElementById(BicarbId).value) + 15;
		}
	} else if ((metAlk === 1) && (acidOrAlk === 1)) {
		if (parseFloat(document.getElementById(BicarbId).value) > NORMAL_BICARB) {
			expectPCO2 = Math.round(((parseFloat(document.getElementById(BicarbId).value) - NORMAL_BICARB) * 0.7) + NORMAL_PCO2);
		}
	}
}

function expectBicarbCalc(caller) {
	"use strict";
	var BicarbId = "", PCO2Id = "", maxCount = 0;
	if (caller === "complex") {
		BicarbId = "c_bicarb";
		PCO2Id = "c_pCO2";
		maxCount = 3;
	} else if (caller === "osmolar") {
		BicarbId = "o_bicarb";
		PCO2Id = "o_pCO2";
		maxCount = 4;
	} else if (caller === "simple") {
		BicarbId = "s_bicarb";
		PCO2Id = "s_pCO2";
		maxCount = 2;
	}
	expectBicarb = NORMAL_BICARB;
	if (getProblemType() === "a") {
		if ((respAcid === 1) && (acidOrAlk === 0)) {
			expectBicarb = Math.round(((parseFloat(document.getElementById(PCO2Id).value) - NORMAL_PCO2) / 10) + NORMAL_BICARB);
		} else if ((respAlk === 1) && (acidOrAlk === 1)) {
			expectBicarb = Math.round(NORMAL_BICARB - ((NORMAL_PCO2 - parseFloat(document.getElementById(PCO2Id).value)) / 5));
		}
	} else {
		if ((respAcid === 1) && (acidOrAlk === 0)) {
			expectBicarb = Math.round(((parseFloat(document.getElementById(PCO2Id).value) - NORMAL_PCO2) / 2.857142) + NORMAL_BICARB);
		} else if ((respAlk === 1) && (acidOrAlk === 1)) {
			expectBicarb = Math.round(((NORMAL_BICARB - ((NORMAL_PCO2 - parseFloat(document.getElementById(PCO2Id).value)) / 2.222222))));
		}
	}
	
}

function evalPCO2(caller) {
	"use strict";
	var PCO2_id = "", BicarbId = "", countMax = 0;
	if (caller === "complex") {
		PCO2_id = "c_pCO2";
		BicarbId = "c_bicarb";
		countMax = 3;
	} else if (caller === "osmolar") {
		PCO2_id = "o_pCO2";
		BicarbId = "o_bicarb";
		countMax = 4;
	} else if (caller === "simple") {
		PCO2_id = "s_pCO2";
		BicarbId = "s_bicarb";
		countMax = 2;
	}
	expectedPCO2Calc(caller);
	
	if ((Math.abs(expectPCO2 - parseFloat(document.getElementById(PCO2_id).value)) > 5) && (parseFloat(document.getElementById(PCO2_id).value) > expectPCO2)) {
		if ((count < countMax) && (respAcid === 0)) {
			count = count + 1;
			respAcid = 1;
		}
	} else if ((parseFloat(document.getElementById(PCO2_id).value) < expectPCO2) && ((Math.abs(expectPCO2 - parseFloat(document.getElementById(PCO2_id).value))) > 5)) {
		if ((count < countMax) && (respAlk === 0)) {
			count = count + 1;
			respAlk = 1;
		}
	} else if ((parseFloat(document.getElementById(PCO2_id).value) >= (expectPCO2 - 5)) && (parseFloat(document.getElementById(PCO2_id).value) <= (expectPCO2 + 5))) {
		if (parseFloat(document.getElementById(PCO2_id).value) < NORMAL_PCO2_LOW) {
			if ((count < countMax) && (respAlk === 0)) {
				count = count + 1;
				respAlk = 1;
			}
		} else if (parseFloat(document.getElementById(PCO2_id).value) > NORMAL_PCO2_HIGH) {
			if ((count < countMax) && (respAcid === 0)) {
				count = count + 1;
				respAcid = 1;
			}
		}
	}
	expectBicarbCalc(caller);
}

function evalBicarb(caller) {
	"use strict";
	var BicarbId = "", PCO2Id = "", maxCount = 0;
	if (caller === "complex") {
		BicarbId = "c_bicarb";
		PCO2Id = "c_pCO2";
		maxCount = 3;
	} else if (caller === "osmolar") {
		BicarbId = "o_bicarb";
		PCO2Id = "o_pCO2";
		maxCount = 4;
	} else if (caller === "simple") {
		BicarbId = "s_bicarb";
		PCO2Id = "s_pCO2";
		maxCount = 2;
	}
	expectBicarbCalc(caller);
	if (((expectBicarb > parseFloat(document.getElementById(BicarbId).value)) && (Math.abs(expectBicarb - parseFloat(document.getElementById(BicarbId).value))) > 3) || ((NORMAL_BICARB_LOW > parseFloat(document.getElementById(BicarbId).value)) && ((expectBicarb + 3) >= parseFloat(document.getElementById(BicarbId).value)) && ((expectBicarb - 3) <= parseFloat(document.getElementById(BicarbId).value)))) {
		if ((respAcid === 1) && (HAGMA === 1) && (metAlk === 1)) {
			NAGMA = 0;
		} else if ((count < maxCount) && (NAGMA === 0)) {
			count = count + 1;
			NAGMA = 1;
		}
	} else if ((((parseFloat(document.getElementById(BicarbId).value) - expectBicarb) > 3) && (expectBicarb < parseFloat(document.getElementById(BicarbId).value))) || ((NORMAL_BICARB_HIGH < parseFloat(document.getElementById(BicarbId).value)) && ((expectBicarb + 3) >= parseFloat(document.getElementById(BicarbId).value)) && ((expectBicarb - 3) <= parseFloat(document.getElementById(BicarbId).value)))) {
		if ((respAcid === 1) && (HAGMA === 1) && (NAGMA === 1)) {
			NAGMA = 0;
			metAlk = 1;
		} else if ((count < maxCount) && (metAlk === 0)) {
			count = count + 1;
			metAlk = 1;
		}
	}
	expectedPCO2Calc(caller);
	
}

function evalAG(caller) {
	"use strict";
	var bicarbID = "";
	var maxC = 0;
	if (caller === "complex") {
		bicarbID = "c_bicarb";
		maxC = 3;
	} else if (caller === "osmolar") {
		bicarbID = "o_bicarb";
		maxC = 4;
	} else {
		//this would be an error
		alert(caller);
	}	
	expectBicarb = NORMAL_BICARB - (calcAG - expectedAG);
	if ((caller === "complex") || (caller === "osmolar")) {
		if ((calcAG - expectedAG) > 3) {
			if ((count < maxC) && (HAGMA === 0)) {
				count = count + 1;
				HAGMA = 1;	
				deltaDelta = ((calcAG - expectedAG) / (NORMAL_BICARB - (parseFloat(document.getElementById(bicarbID).value))));
				if ((deltaDelta > 2) || (deltaDelta < 0)) {
					if ((count < maxC) && (metAlk === 0)) {
						count = count + 1;
						metAlk = 1;
					}
				} else if ((deltaDelta < 1) && (deltaDelta > 0)) {
					if ((count < maxC) && (NAGMA === 0)) {
						count = count + 1;
						NAGMA = 1;
					}
				}
			}
		} else if (calcAG < 0) {
			if ((count < maxC) && (negAG === 0)) {
				count = count + 1;
				negAG = 1;
			}
		}
	} else {
		// this would be an error.
		alert("error 3!");
		//simple shouldn't be calling this.
	}
}
function evalOG(whoCalled) {
	"use strict";
	if (whoCalled === "osmolar") {
		if ((osmolarGap > 10) && (HAGMA === 1)) {
			bothOGAG = 2;
		} else if ((osmolarGap > 10) && (HAGMA != 1)) {
			bothOGAG = 1;
		} else {
			bothOGAG = 0;
		}
	} else if (whoCalled === "OG") {
		if (osmolarGap > 10) {
			bothOGAG = 3;
		} else {
			bothOGAG = 0;
		}
	} else {
		alert(whoCalled);
		//this is an error nothing else should call this
	}
}
function calculator(caller) {
	"use strict";
	var maximumCount = 0;
	//for acidic calculations
	//bacause acidOrAlk is always set to 0 the OG page's calculations go here also
	if (acidOrAlk === 0) {
		if (caller === "simple") {
			maximumCount = 2;
			if ((parseFloat(document.getElementById('s_pCO2').value) <= NORMAL_PCO2_LOW) || (parseFloat(document.getElementById('s_bicarb').value) < NORMAL_BICARB_LOW)) {
				if ((count < maximumCount) && (NAGMA === 0)) {
					count = count + 1;
					NAGMA = 1;
				}
				evalPCO2(caller);
			} else if ((parseFloat(document.getElementById('s_pCO2').value) > NORMAL_PCO2_HIGH) || (parseFloat(document.getElementById('s_bicarb').value) >= NORMAL_BICARB_HIGH)) {
				if ((count < maximumCount) && (respAcid === 0)) {
					count = count + 1;
					respAcid = 1;
				}
				evalBicarb(caller);	
			}
		} else if (caller === "complex") {
			maximumCount = 3;
			evalAG(caller);
			if ((parseFloat(document.getElementById('c_pCO2').value) <= NORMAL_PCO2_LOW) || (parseFloat(document.getElementById('c_bicarb').value) < NORMAL_BICARB_LOW)) {
				if (HAGMA === 1) {
					//do nothing
				} else if ((count < maximumCount) && (NAGMA === 0)) {
					count = count + 1;
					NAGMA = 1;
				}
				evalPCO2(caller);
			} else if ((parseFloat(document.getElementById('c_pCO2').value) > NORMAL_PCO2_HIGH) || (parseFloat(document.getElementById('c_bicarb').value) > NORMAL_BICARB_HIGH)) {
				if ((count < maximumCount) && (respAcid === 0)) {
					count = count + 1;
					respAcid = 1;
					if (HAGMA !== 1) {
						evalBicarb(caller);
					}
				}
			}
		
		} else if (caller === "osmolar") {
			maximumCount = 4;
			evalAG(caller);
			if ((parseFloat(document.getElementById('o_pCO2').value) <= NORMAL_PCO2_LOW) || (parseFloat(document.getElementById('o_bicarb').value) < NORMAL_BICARB_LOW)) {
				if (HAGMA === 1) {
					//do nothing
				} else if ((count < maximumCount) && (NAGMA === 0)) {
					count = count + 1;
					NAGMA = 1;
				}
				evalPCO2(caller);
			} else if ((parseFloat(document.getElementById('o_pCO2').value) > NORMAL_PCO2_HIGH) || (parseFloat(document.getElementById('o_bicarb').value) > NORMAL_BICARB_HIGH)) {
				if ((count < maximumCount) && (respAcid === 0)) {
					count = count + 1;
					respAcid = 1;
					if (HAGMA !== 1) {
						evalBicarb(caller);
					}
				}
			}
			osmolarGap = (parseFloat(document.getElementById('o_sosm').value) - calcOsm);
			evalOG('osmolar');
		} else if (caller === "OG") {
			osmolarGap = (parseFloat(document.getElementById('og_sosm').value) - calcOsm);
			evalOG("OG");
		}
	} else {
		//for basic calculations
		if (caller === "simple") {
			maximumCount = 2;
			if ((parseFloat(document.getElementById('s_pCO2').value) < NORMAL_PCO2_LOW) || (parseFloat(document.getElementById('s_bicarb').value) < NORMAL_BICARB_LOW)) {
				if ((count < maximumCount) && (respAlk === 0)) {
					count = count + 1;
					respAlk = 1;
				}
				evalBicarb(caller);
			} else if ((parseFloat(document.getElementById('s_pCO2').value) >= NORMAL_PCO2_HIGH) || (parseFloat(document.getElementById('s_bicarb').value) > NORMAL_BICARB_HIGH)) {
				if ((count < maximumCount) && (metAlk === 0)) {
					count = count + 1;
					metAlk = 1;
				}
				evalPCO2(caller);
			}			
		} else if (caller === "complex") {
			maximumCount = 3;
			evalAG(caller);
			if ((parseFloat(document.getElementById('c_pCO2').value) < NORMAL_PCO2_LOW) || (parseFloat(document.getElementById('c_bicarb').value) < NORMAL_BICARB_LOW)) {
				if ((count < maximumCount) && (respAlk === 0)) {
					count = count + 1;
					respAlk = 1;
					if (HAGMA !== 1) {
						evalBicarb(caller);
					}
				}
			} else if ((parseFloat(document.getElementById('c_pCO2').value) >= NORMAL_PCO2_HIGH) || (parseFloat(document.getElementById('c_bicarb').value) > NORMAL_BICARB_HIGH)) {
				if ((HAGMA === 1) && (respAcid === 1) && (NAGMA === 1)) {
					NAGMA = 0;
					metAlk = 1;
				} else if ((count < maximumCount) && (metAlk === 0)) {
					count = count + 1;
					metAlk = 1;
				}
				evalPCO2(caller);
			}
		} else if (caller === "osmolar") {
			maximumCount = 4;
			evalAG(caller);
			if ((parseFloat(document.getElementById('o_pCO2').value) < NORMAL_PCO2_LOW) || (parseFloat(document.getElementById('o_bicarb').value) < NORMAL_BICARB_LOW)) {
				if ((count < maximumCount) && (respAlk === 0)) {
					count = count + 1;
					respAlk = 1;
					if (HAGMA !== 1) {
						evalBicarb(caller);
					}
				}
			} else if ((parseFloat(document.getElementById('o_pCO2').value) >= NORMAL_PCO2_HIGH) || (parseFloat(document.getElementById('o_bicarb').value) > NORMAL_BICARB_HIGH)) {
				if ((HAGMA === 1) && (respAcid === 1) && (NAGMA === 1)) {
					NAGMA = 0;
					metAlk = 1;
				} else if ((count < maximumCount) && (metAlk === 0)) {
					count = count + 1;
					metAlk = 1;
				}
				evalPCO2(caller);
			}
			osmolarGap = (parseFloat(document.getElementById('o_sosm').value) - calcOsm);
			evalOG('osmolar');
		}
	}
	
}
function calculateAA(caller) {
	"use strict";
	if (caller != "AA"){
		//nothing to do.
	}
	else {
		aaGradient = (parseFloat(document.getElementById('aa_FiO2').value) * ((parseFloat(document.getElementById('aa_atm').value) - 47) - (parseFloat(document.getElementById('aa_PCO2').value)/0.8))) - (parseFloat(document.getElementById('aa_PO2').value));
		normalAAGradient = (parseFloat(document.getElementById('aa_age').value) + 10) / 4; 
	}

}
function assignAcid(acidDisorder) {
	"use strict";
	if ((finalAnswer[0] === "0") && ((acidDisorder === "OGOG") || (acidDisorder === "OGAG") || (acidDisorder === "OG") || (acidDisorder === "HAGMA") || (acidDisorder === "NAGMA") || (acidDisorder === "respAcid") || (acidDisorder === "negAG"))) {
			finalAnswer[0] = acidDisorder;
	} else if (finalAnswer[1] === "0") {
		if ((((HAGMA === 1) || (NAGMA === 1)) && (acidDisorder === "respAlk")) || ((acidDisorder === "metAlk") && (respAcid === 1))) {
			if (compensate === 0) {
				compensate = 1;
			}
		}
		finalAnswer[1] = acidDisorder; 
	} else if (finalAnswer[2] === "0") {
		if ((((HAGMA === 1) || (NAGMA === 1)) && (acidDisorder === "respAlk")) || ((acidDisorder === "metAlk") && (respAcid === 1))) {
			if (compensate === 0) {
				compensate = 2;
			}
		} 
		finalAnswer[2] = acidDisorder; 
	} else if (finalAnswer[3] === "0") {
		finalAnswer[3] = acidDisorder;
	}
	//special cases
	//(1)	If the overall state is acidemic and results contain an alkalosis/resp acidosis
	//		and a met acidosis then most likely the met acidosis is the primary disorder.
	if (finalAnswer[0] === "respAcid") {
		if ((finalAnswer[1] === "metAlk") && (finalAnswer[2] === "HAGMA")) {
			finalAnswer[0] = "HAGMA";
			finalAnswer[2] = "respAcid";
			compensate = 2;
		} else if ((finalAnswer[2] === "metAlk") && (finalAnswer[1] === "HAGMA")) {
			finalAnswer[0] = "HAGMA";
			finalAnswer[1] = "metAlk";
			finalAnswer[2] = "respAcid";
			compensate = 2;
		} else if ((finalAnswer[1] === "metAlk") && (finalAnswer[2] === "NAGMA")) {
			finalAnswer[0] = "NAGMA";
			finalAnswer[2] = "respAcid";
			compensate = 2;
		} else if ((finalAnswer[2] === "metAlk") && (finalAnswer[1] === "NAGMA")) {
			finalAnswer[0] = "NAGMA";
			finalAnswer[1] = "metAlk";
			finalAnswer[2] = "respAcid";
			compensate = 2;
		}
	} 
}
function assignBase(baseDisorder) {
	"use strict";
	if ((finalAnswer[0] === "0") && ((baseDisorder === "OG") || (baseDisorder === "OGAG") || (baseDisorder === "metAlk") || (baseDisorder === "respAlk") || (baseDisorder === "negAG"))) {
			finalAnswer[0] = baseDisorder;
	} else if (finalAnswer[1] === "0") {
		if (((baseDisorder === "respAcid") && (metAlk === 1)) || ((baseDisorder === "NAGMA") && (respAlk === 1))) {
			if (compensate === 0) {
				compensate = 1;
			}
		}
		finalAnswer[1] = baseDisorder;
	} else if ((finalAnswer[2] === "0")) {
		if (((baseDisorder === "respAcid") && metAlk === 1) || ((baseDisorder === "NAGMA") && (respAlk === 1))) {
			if (compensate === 0) {
				compensate = 2;
			}
		}
		finalAnswer[2] = baseDisorder;
	} else if (finalAnswer[3] === "0") {
		finalAnswer[3] = baseDisorder;
	}
	//special cases
	//(1)	If the overall state is alkalemic and results contain an acidosis/resp alkalosis
	//		and a met alkalosis then most likely the met alkalosis is the primary disorder.
	if (finalAnswer[0] === "respAlk") {
		if ((finalAnswer[1] === "metAlk") && (finalAnswer[2] === "HAGMA")) {
			finalAnswer[0] = "metAlk";
			finalAnswer[1] = "HAGMA";
			finalAnswer[2] = "respAlk";
			compensate = 2;
		} else if ((finalAnswer[2] === "metAlk") && (finalAnswer[1] === "HAGMA")) {
			finalAnswer[0] = "metAlk";
			finalAnswer[2] = "respAlk";
			compensate = 2;
		} else if ((finalAnswer[1] === "metAlk") && (finalAnswer[2] === "NAGMA")) {
			finalAnswer[0] = "metAlk";
			finalAnswer[1] = "NAGMA";
			finalAnswer[2] = "respAlk";
			compensate = 2;
		} else if ((finalAnswer[2] === "metAlk") && (finalAnswer[1] === "NAGMA")) {
			finalAnswer[0] = "metAlk";
			finalAnswer[2] = "respAlk";
			compensate = 2;
		}
	} 
}
function assignLevel(disorderType) {
	"use strict";
	if (acidOrAlk === 0) {
		assignAcid(disorderType);
	} else {
		assignBase(disorderType);
	}
}
function assignLevelCaller() {
	"use strict";
	if (negAG === 1) {
		assignLevel('negAG');
	}
	if (HAGMA === 1) {
		assignLevel("HAGMA");
	}
	if (NAGMA === 1) {
		assignLevel("NAGMA");
	}
	if (respAlk === 1) {
		assignLevel("respAlk");
	}
	if (respAcid === 1) {
		assignLevel("respAcid");
	}
	if (metAlk === 1) {
		assignLevel("metAlk");
	}
	if (bothOGAG === 3) {
		assignLevel("OGOG");
	} else if (bothOGAG === 2) {
		assignLevel("OGAG");
	} else if (bothOGAG === 1) {
		assignLevel("OG");
	}
}
function returnDefinition(whichAnswer) {
	"use strict";
	var answerDefArray = new Array(2);
	answerDefArray[0] = "";
	answerDefArray[1] = "";
	
	if (whichAnswer === "HAGMA") {
		answerDefArray[0] = "Anion Gap Metabolic Acidosis";
		answerDefArray[1] = "Differential Diagnosis: <ol> <li>Lactic acidosis (Type A secondary to shock; Type B impaired clearance or when cells are unable to use delivered oxygen)</li> <li>Ketoacidosis (Diabetic ketoacidosis, Alcohol abuse and starvation)</li> <li>Toxins: Iron, Paraldehyde, Isoniazid, Toluene, Ethylene glycol, Methanol, Propylene Glycol, Salicylates, Aspirin, Cyanide (coupled with elevated venous oxygenation).</li> <li>Advanced Renal failure, causes high anion gap acidosis by decreased acid excretion and decreased HCO3- reabsorption. Accumulation of sulfates, phosphates, urate, and hippurate accounts for the high anion gap.</li> </ol>";
	} else if (whichAnswer === "NAGMA") {
		answerDefArray[0] = "Non-AG Metabolic Acidosis";
		answerDefArray[1] = "Differential Diagnosis: <ol> <li>Hyperalimentation \n </li> <li>Acetazolamide and other carbonic anhydrase inhibitors </li> <li>Renal tubular acidosis & Mod Renal Insufficiency (without the sulfates, phosphates, urate etc build up) </li> <li>Diarrhea </li> <li>Ureteroenteric fistula - an abnormal connection between a ureter and the gastrointestinal tract </li> <li>Pancreaticoduodenal fistula - an abnormal connection between the pancreas and duodenum. </li> <li>Saline: Very Large volume.</li> </ol>";
	} else if (whichAnswer === "respAlk") {
		answerDefArray[0] = "Resp Alkalosis";
		answerDefArray[1] = "Differential Diagnosis: <ol> <li>Iatrogenic via excessive mechanical ventilation. </li> <li>Psychiatric causes: Anxiety, Stress </li> <li>CNS causes: Stroke, Subarachnoid Hemorrhage, Meningitis </li> <li>Drug use: Aspirin, Caffeine, Progesterone </li> <li>Hypoxemia: Asthma exacerbation with good airflow, Acute Pulm Edema, Pulmonary Embolus, High Altitude, Pneumonia. </li> <li>Respiratory Compensation for Metabolic Acidosis (generally hyperchloremic). </li> </ol>";
	} else if (whichAnswer === "respAcid") {
		answerDefArray[0] = "Resp Acidosis";
		answerDefArray[1] = "Differential Diagnosis: <ol> <li>Respiratory compensation for metabolic alkalosis. </li> <li> Inadequate Alveolar Ventilation: Central Respiratory Depression secondary to drugs (eg by opiates, sedatives, anaesthetics) or CNS disease. </li> <li>Hypoventilation of obesity: eg Pickwickian syndrome.</li> <li>Nerve or Muscle Disorders: Guillain-Barre Syndrome, Myasthemia Gravis, Various myopathies etc. </li> <li>Lung Defect: COPD, Asthma, Pneumothorax, Diaphragmatic paralysis/splinting, Pulmonary edema, ARDS, Restrictive lung disease, Respiratory Compensation for Metabolic Alkalosis etc. </li> <li>Airway Disorders: Laryngospasm, Upper airway obstruction. </li> <li>Iatrogenic: Via Inadequate mechanical ventilation</li> </ol>";
	} else if (whichAnswer === "metAlk") {
		answerDefArray[0] = "Metabolic Alkalosis";
		answerDefArray[1] = "Differential Diagnosis: <ol> <li>Chloride-responsive (Urine Cl &lt; 20 mEq/L): GI Loses (vomiting, NG Suctioning etc), Diuretic Use (other than acetazolamide) causing contraction alkalosis, Recovery from chronic hypercapnia. </li> <li>Chloride-resistant (Urine Cl &gt; 20 mEq/L): Bartter's & Gitelman's Syndrome, Excessive alkali (ex: Milk Alkali, Massive citrate with blood products), Mineralocorticoid excess, Severe hypokalemia, Renal Compensation for Resp Acidosis.</li> </ol>";
	} else if (whichAnswer === "negAG") {
		answerDefArray[0] = "Negative Anion Gap";
		answerDefArray[1] = "Differential Diagnosis: <ol> <li>Laboratory error (Most frequent cause)</li> <li>Toxins: Bromide (Second most common cause), Iodide etc.</li> <li>Multiple myeloma: Level of anion gap correlates with serum concentration of paraprotein - usually a low AG not a negative one.</li> </ol>";
	} else if (whichAnswer === "OG") {
		answerDefArray[0] = "Elevated Osmolar Gap";
		answerDefArray[1] = "Differential Diagnosis: <ol> <li>Ethanol (without ketoacidosis)</li> <li>Isopropanol</li> <li>Acetone</li> <li>Glycerol</li> <li>Mannitol</li> <li>Sorbitol </li> </ol>";
	} else if (whichAnswer === "OGAG") {
		answerDefArray[0] = "Both Osmolar Gap and Anion Gap Elevated";
		answerDefArray[1] = "Differential Diagnosis: <ol> <li>Ethylene Glycol</li> <li>Diabetic Ketoacidosis</li> <li>Ethanol induced Ketoacidos </li> <li>Lactic Acidosis </li> <li>Methanol</li> <li>Chronic Kidney Disease</li> </ol>";
	} else if (whichAnswer === "OGOG") {
		answerDefArray[0] = "All Causes of Elevated Osmolar Gap";
		answerDefArray[1] = "Differential Diagnosis: <ol> <li>Ethylene Glycol</li> <li>Diabetic Ketoacidosis</li> <li>Ethanol induced Ketoacidos </li> <li>Lactic Acidosis </li> <li>Methanol</li> <li>Chronic Kidney Disease</li>  <li>Ethanol (without ketoacidosis)</li> <li>Isopropanol</li> <li>Acetone</li> <li>Glycerol</li> <li>Mannitol</li> <li>Sorbitol </li> </ol>";
	} else if (whichAnswer === "AA") {
		answerDefArray[0] = "Elevated A-a Gradient";
		answerDefArray[1] = "An abnormally increased A-a gradient suggests a defect in:  <ol> <li> Diffusion (ex: ILD, Diffuse PNA, ARDS etc.) </li><li> V/Q mismatch (ex: Lobar PNA, CHF, PE, atelectasis etc.)</li><li> Right-to-left shunt(ex: PFO, ASD, pulmonary AVMs etc.). </li></ol> Hypoventilation and Low FiO2 intake cause hypoxia without an elevated A-a Gradient.";
	}
	return answerDefArray;
}
function setAnswer(position, whichAnswer, compensation) {
	"use strict";
	var toBePrinted = new Array(2);
	if (position === 0) {
		if ((whichAnswer === "OGOG") || (whichAnswer === "OG") || (whichAnswer === "OGAG") || (whichAnswer === "AA")) {
			toBePrinted = returnDefinition(whichAnswer);
			document.getElementById('answer1').innerHTML = "<h3> " + toBePrinted[0] + "</h3> <p>" + toBePrinted[1] + "</p>";			
		} else {
			toBePrinted = returnDefinition(whichAnswer);
			document.getElementById('answer1').innerHTML = "<h3> Primary " + toBePrinted[0] + "</h3> <p>" + toBePrinted[1] + "</p>";			
		}
		toggle("answer1", "show");
		toggle("answer2", "hide");
		toggle("answer3", "hide");
		toggle("answer4", "hide");
		toggle("answer5", "hide");
	} else if (position === 1) {
		if (compensation === 1) {
			toBePrinted = returnDefinition(whichAnswer);
			document.getElementById('answer2').innerHTML = "<h3> Secondary and / or Compensatory " + toBePrinted[0] + "</h3> <p>" + toBePrinted[1] + "</p>";
		} else if ((whichAnswer === "OGOG") || (whichAnswer === "OG") || (whichAnswer === "OGAG")) {
			toBePrinted = returnDefinition(whichAnswer);
			document.getElementById('answer2').innerHTML = "<h3> " + toBePrinted[0] + "</h3> <p>" + toBePrinted[1] + "</p>";			
		} else {
			toBePrinted = returnDefinition(whichAnswer);
			document.getElementById('answer2').innerHTML = "<h3> Secondary " + toBePrinted[0] + "</h3> <p>" + toBePrinted[1] + "</p>";
		}
		toggle("answer1", "show");
		toggle("answer2", "show");
		toggle("answer3", "hide");
		toggle("answer4", "hide");
		toggle("answer5", "hide");
	} else if (position === 2) {
		if (compensation === 2) {
			toBePrinted = returnDefinition(whichAnswer);
			document.getElementById('answer3').innerHTML = "<h3> Tertiary and / or Compensatory " + toBePrinted[0] + "</h3> <p>" + toBePrinted[1] + "</p>";
		} else if ((whichAnswer === "OGOG") || (whichAnswer === "OG") || (whichAnswer === "OGAG")) {
			toBePrinted = returnDefinition(whichAnswer);
			document.getElementById('answer3').innerHTML = "<h3> " + toBePrinted[0] + "</h3> <p>" + toBePrinted[1] + "</p>";			
		} else {
			toBePrinted = returnDefinition(whichAnswer);
			document.getElementById('answer3').innerHTML = "<h3> Tertiary " + toBePrinted[0] + "</h3> <p>" + toBePrinted[1] + "</p>";
		}
		toggle("answer1", "show");
		toggle("answer2", "show");
		toggle("answer3", "show");
		toggle("answer4", "hide");
		toggle("answer5", "hide");
	} else if (position === 3) {
		toBePrinted = returnDefinition(whichAnswer);
		document.getElementById('answer4').innerHTML = "<h3> " + toBePrinted[0] + "</h3> <p>" + toBePrinted[1] + "</p>";
		toggle("answer1", "show");
		toggle("answer2", "show");
		toggle("answer3", "show");
		toggle("answer4", "show");
		toggle("answer5", "hide");
	}
}

function displayError(whatError) {
	"use strict";
	document.getElementById('answer1').innerHTML = "<h3> Error! </h3> <p>" + whatError + "</p>";
	toggle("answer1", "show");
	toggle("answer2", "hide");
	toggle("answer3", "hide");
	toggle("answer4", "hide");
	window.location.href = "index.html#answer";
	error = 0;
	errorText = "";
}

function reporter() {
	"use strict";
	var i = 0;
	var calculationsText = "";
	var calcCount = 0;
	var printedNum = 0;
	//for Aa Gradient page.
	//for everything else
	if ((bothOGAG != 0) || (HAGMA === 1) || (NAGMA === 1) || (respAlk === 1) || (metAlk === 1) || (respAcid === 1) || (negAG === 1)) {
		for (i = 0; i < 4; i++) {
			if (finalAnswer[i] !== "0") {
				setAnswer(i, finalAnswer[i], compensate);
			}
		}
	} else if ((aaGradient - normalAAGradient) > 10) {
			setAnswer(0, "AA", 0);
	} else {
		var testCpH = parseFloat(document.getElementById('c_pH').value);
		var testSpH = parseFloat(document.getElementById('s_pH').value); 
		var testOpH = parseFloat(document.getElementById('o_pH').value);
		if ((testCpH < 7.35) || (testSpH < 7.35) || (testOpH < 7.35)) {
			displayError("There are no acid-base abnormalities. However, the entered pH is acidotic. Are you sure you have entered the correct values?");			
		} 
		else if ((testCpH > 7.45) || (testSpH > 7.45) || (testOpH > 7.45)) {
			displayError("There are no acid-base abnormalities. However, the entered pH is alkalotic. Are you sure you have entered the correct values?");
		}
		else {
			displayError("There are no acid-base abnormalities.");
		}
	}
	// for calculations;
	calculationsText = "<h4> Calculations </h4> <p> <ul>";
	if (bothOGAG != 0) {
		printedNum = osmolarGap;
		calculationsText = calculationsText + "<li> Osmolar Gap - " + printedNum.toFixed(2) + "</li>";
		calcCount = calcCount + 1;
	}
	if ((HAGMA === 1) || (NAGMA === 1) || (respAlk === 1) || (metAlk === 1) || (respAcid === 1)) {
		printedNum = expectPCO2;
		calculationsText = calculationsText + "<li> Expected PCO2 - " + printedNum.toFixed(2) + " </li>";
		printedNum = expectBicarb;
		calculationsText = calculationsText + "<li> Expected Bicarb - " + printedNum.toFixed(2) + "</li>";
		calcCount = calcCount + 1;
	}
	if (HAGMA === 1) {
		printedNum = calcAG;
		calculationsText = calculationsText + "<li> Calculated AG - " + printedNum.toFixed(2) + "</li>";
		printedNum = Math.abs(deltaDelta);
		calculationsText = calculationsText + "<li> Delta Delta - " + printedNum.toFixed(2) + "</li>";
		calcCount = calcCount + 1;
	}
	if ((aaGradient - normalAAGradient) > 10) {
		printedNum = normalAAGradient;
		calculationsText = calculationsText + "<li> Normal Aa Gradient for Age - " + printedNum.toFixed(2) + "</li>";
		printedNum = aaGradient;
		calculationsText = calculationsText + "<li> Calculated Aa Gradient - " + printedNum.toFixed(2) + "</li>";
		calcCount = calcCount + 1;
	}
	calculationsText = calculationsText + "</ul></p>";
	if (calcCount > 0) {
		document.getElementById('answer5').innerHTML =  calculationsText;
		toggle('answer5', 'show');
	}
	
}
function onlyReset(){
	"use strict";
	deltaDelta = 0;
	acidOrAlk = 0;
	NAGMA = 0;
	HAGMA = 0;
	respAcid = 0;
	metAlk = 0;
	respAlk = 0;
	error = 0;
	errorText = "";
	count = 0;
	expectPCO2  = 0;
	expectBicarb = 0;
	compensate = 0;
	albumin = 0;
	glucose = 0;
	BUN = 0;
	negAG = 0;
	compensatoryText = "";
	finalAnswer[0] = "0";
	finalAnswer[1] = "0";
	finalAnswer[2] = "0";
	finalAnswer[3] = "0";
	expectedAG = 0;
	calcAG = 0;
	calcOsm = 0;
	osmolarGap = 0;
	bothOGAG = 0;
	document.getElementById('answer1').innerHTML = "";
	document.getElementById('answer2').innerHTML = "";
	document.getElementById('answer3').innerHTML = "";
	document.getElementById('answer4').innerHTML = "";
	document.getElementById('answer5').innerHTML = "";
	aaGradient = 0;
	normalAAGradient = 0;
}

function resetValues(whichCalc) {
	"use strict";
	deltaDelta = 0;
	acidOrAlk = 0;
	NAGMA = 0;
	HAGMA = 0;
	respAcid = 0;
	metAlk = 0;
	respAlk = 0;
	error = 0;
	errorText = "";
	count = 0;
	expectPCO2  = 0;
	expectBicarb = 0;
	compensate = 0;
	albumin = 0;
	glucose = 0;
	BUN = 0;
	negAG = 0;
	compensatoryText = "";
	finalAnswer[0] = "0";
	finalAnswer[1] = "0";
	finalAnswer[2] = "0";
	finalAnswer[3] = "0";
	expectedAG = 0;
	calcAG = 0;
	calcOsm = 0;
	osmolarGap = 0;
	bothOGAG = 0;
	document.getElementById('answer1').innerHTML = "";
	document.getElementById('answer2').innerHTML = "";
	document.getElementById('answer3').innerHTML = "";
	document.getElementById('answer4').innerHTML = "";
	document.getElementById('answer5').innerHTML = "";
	aaGradient = 0;
	normalAAGradient = 0;
	pageCaller = whichCalc;

	document.getElementById('backButton').href = "#" + pageCaller;
	if (pageCaller != "AA") {
		if (pageCaller != "OG"){
			errorCheckForNormalBicarb();
			errorCheckForNormalPCO2();	
		}
		errorCheckSetAGOrOsm(pageCaller);
	}
	else {
		errorCheckAA(pageCaller);
	}
	if (error === 0) {
		if (pageCaller != "AA") {
			if (pageCaller != "simple") {
				SIConversionAndCalculator(pageCaller);
			}
			calculator(pageCaller);
			assignLevelCaller();
		}
		else {
			calculateAA(pageCaller);
		}
		reporter();
	} else {
		displayError(errorText);
	}
}





function hintOff(obj) {
	"use strict";
	if ((obj === "lowBicarb") && (document.getElementById(obj).value === "23")) {
		document.getElementById(obj).value = "";
	} else if ((obj === "highBicarb") && (document.getElementById(obj).value === "28")) {
		document.getElementById(obj).value = "";
	} else if ((obj === "lowpCO2") && (document.getElementById(obj).value === "35")) {
		document.getElementById(obj).value = "";
	} else if ((obj === "highpCO2") && (document.getElementById(obj).value === "45")) {
		document.getElementById(obj).value = "";
	} else if ((obj === "aa_atm") && (document.getElementById(obj).value === "760")) {
		document.getElementById(obj).value = "";
	} else if ((obj === "aa_FiO2") && (document.getElementById(obj).value === "0.21")) {
		document.getElementById(obj).value = "";
	}
	
	if (document.getElementById('siUnits').checked === true) {
		if ((obj === "o_alb") && (document.getElementById(obj).value === "40")) {
			document.getElementById(obj).value = "";
		} else if ((obj === "c_alb") && (document.getElementById(obj).value === "40")) {
			document.getElementById(obj).value = "";
		}
	} else {
		if ((obj === "o_alb") && (document.getElementById(obj).value === "4")) {
			document.getElementById(obj).value = "";
		} else if ((obj === "c_alb") && (document.getElementById(obj).value === "4")) {
			document.getElementById(obj).value = "";
		}
	}
}

function hintOn(obj) {
	"use strict";
	if ((obj === "lowBicarb") && (document.getElementById(obj).value === "")) {
		document.getElementById(obj).value = 23;
	} else if ((obj === "highBicarb") && (document.getElementById(obj).value === "")) {
		document.getElementById(obj).value = 28;
	} else if ((obj === "lowpCO2") && (document.getElementById(obj).value === "")) {
		document.getElementById(obj).value = 35;
	} else if ((obj === "highpCO2") && (document.getElementById(obj).value === "")) {
		document.getElementById(obj).value = 45;
	} else if ((obj === "aa_atm") && (document.getElementById(obj).value === "")) {
		document.getElementById(obj).value = "760";
	} else if ((obj === "aa_FiO2") && (document.getElementById(obj).value === "")) {
		document.getElementById(obj).value = "0.21";
	}
	
	if (document.getElementById('siUnits').checked === true) {
		if ((obj === "o_alb") && (document.getElementById(obj).value === "")) {
			document.getElementById(obj).value = 40;
		} else if ((obj === "c_alb") && (document.getElementById(obj).value === "")) {
			document.getElementById(obj).value = 40;
		}
	} else {
		if ((obj === "o_alb") && (document.getElementById(obj).value === "")) {
			document.getElementById(obj).value = 4;
		} else if ((obj === "c_alb") && (document.getElementById(obj).value === "")) {
			document.getElementById(obj).value = 4;
		}
	}
}
////////////////////////////////////////////////////////////
function clearOptions() {
	"use strict";

	//var radioList = document.optionsF.problemType;
    
    $( "#siUnits" ).prop( "checked", false ).checkboxradio( "refresh" );
	document.getElementById('lowBicarb').value = 23;
	document.getElementById('highBicarb').value = 28;
	document.getElementById('lowpCO2').value = 35;
	document.getElementById('highpCO2').value = 45;
    

    $( "#chronicProblem" ).prop( "checked", false ).checkboxradio( "refresh" );
    $( "#acuteProblem" ).prop( "checked", true ).checkboxradio( "refresh" );
}


function errorCheckForNormalBicarb() {
	"use strict";
	NORMAL_BICARB_HIGH = null;
	NORMAL_BICARB_LOW = null;
	if ((parseFloat(document.getElementById('lowBicarb').value) >= 23) && (parseFloat(document.getElementById('lowBicarb').value) <= 27)) {
		if (document.getElementById('highBicarb').value === "") {
			error = 1;
			errorText = errorText + "Please provide the high-normal for bicarb also. \n";
		} else if ((parseFloat(document.getElementById('highBicarb').value) >= 24) && (parseFloat(document.getElementById('highBicarb').value) <= 28) && ((parseFloat(document.getElementById('lowBicarb').value) < (parseFloat(document.getElementById('highBicarb').value))))) {
			NORMAL_BICARB_HIGH = parseFloat(document.getElementById('highBicarb').value);
			NORMAL_BICARB_LOW = parseFloat(document.getElementById('lowBicarb').value);
		} else {
			error = 1;
			errorText = errorText + "High-normal values for bicarb should fall between 24 to 28. \n";
		}
	} else {
		error = 1;
		errorText = errorText + "Low-normal values for bicarb should fall between 23 to 27. \n";
	}
}

function errorCheckForNormalPCO2() {
	"use strict";
	NORMAL_PCO2_HIGH = null;
	NORMAL_PCO2_LOW = null;
	if ((parseFloat(document.getElementById('lowpCO2').value) >= 35) && (parseFloat(document.getElementById('lowpCO2').value) <= 39)) {
		if (document.getElementById('highpCO2').value === "") {
			error = 1;
			errorText = errorText + "Please provide the high-normal for PCO2 also. \n";
		} else if ((parseFloat(document.getElementById('highpCO2').value) >= 40) && (parseFloat(document.getElementById('highpCO2').value) <= 45) && ((parseFloat(document.getElementById('lowpCO2').value) < (parseFloat(document.getElementById('highpCO2').value))))) {
			NORMAL_PCO2_HIGH = parseFloat(document.getElementById('highpCO2').value);
			NORMAL_PCO2_LOW = parseFloat(document.getElementById('lowpCO2').value);
		} else {
			error = 1;
			errorText = errorText + "High-normal values for PCO2 should fall between 40 to 45. \n";
		}
	} else {
		error = 1;
		errorText = errorText + "Low-normal values for PCO2 should fall between 35 to 39. \n";
	}
}

function saveOptions() {
	"use strict";
	errorCheckForNormalBicarb();
	errorCheckForNormalPCO2();
	if (error === 0) {
		if (document.getElementById('siUnits').checked === true) {
			//window.localStorage.setItem("useSIUnits", "yes");
            NativeStorage.putString("useSIUnits","yes", storedValueSuccess, storedValueError);
		} else {
			//window.localStorage.setItem("useSIUnits", "no");
            NativeStorage.putString("useSIUnits","no", storedValueSuccess, storedValueError);
		}
		
		NORMAL_BICARB_LOW = document.getElementById('lowBicarb').value;
		//window.localStorage.setItem("NORMAL_BICARB_LOW", NORMAL_BICARB_LOW);
        NativeStorage.putString("NORMAL_BICARB_LOW",NORMAL_BICARB_LOW, storedValueSuccess, storedValueError);
        
		
		NORMAL_BICARB_HIGH = document.getElementById('highBicarb').value;
		//window.localStorage.setItem("NORMAL_BICARB_HIGH", NORMAL_BICARB_HIGH);
        NativeStorage.putString("NORMAL_BICARB_HIGH",NORMAL_BICARB_HIGH, storedValueSuccess, storedValueError);
		
		NORMAL_PCO2_LOW = document.getElementById('lowpCO2').value;
		//window.localStorage.setItem("NORMAL_PCO2_LOW", NORMAL_PCO2_LOW);
        NativeStorage.putString("NORMAL_PCO2_LOW",NORMAL_PCO2_LOW, storedValueSuccess, storedValueError);
		
		NORMAL_PCO2_HIGH = document.getElementById('highpCO2').value;
		//window.localStorage.setItem("NORMAL_PCO2_HIGH", NORMAL_PCO2_HIGH);
        NativeStorage.putString("NORMAL_PCO2_HIGH",NORMAL_PCO2_HIGH, storedValueSuccess, storedValueError);
		
		if ($('input[name=problemType]:checked', '#optionsF').val() == "a") {
			//window.localStorage.setItem("problemType", "acute");
            NativeStorage.putString("problemType","acute", storedValueSuccess, storedValueError);
		} else {
			//window.localStorage.setItem("problemType", "chronic");
            NativeStorage.putString("problemType","chronic", storedValueSuccess, storedValueError);
		}
		window.location.href = "index.html#index";
	} else {
		document.getElementById('backButton').href = "#options";
		displayError(errorText);
	}
    setSIUnits();
}

function storedValueSuccess(obj) {
    console.log(obj);
    //alert(obj);
}
function storedValueError(error) {
    console.log(error.code);
    if (error.exception !== "") {
        console.log(error.exception);
    }
}


